import { J as Json, O as ObjectStorage, L as LogHandlerOptions, d5 as LogMessage, a as LogHandler } from './uuid-79482d19.js';
export { dH as ArgumentsType, cz as AsyncMutex, cU as AsyncReturnType, _ as BinInput, d as CRYPTO_DEFAULT_ALG, e as CRYPTO_DEFAULT_DERIVE_ALG, f as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, df as Channel, de as ChannelMessageEvent, du as CryptoEncoder, ay as DAY_MS, aX as Day, aA as DayInput, aW as DayInputLegacy, az as DayValue, b1 as DecimalInput, b0 as DecimalValue, dl as DefaultListener, cp as Disposable, co as Disposer, cn as DisposerFunction, dm as Emitter, dj as EmitterAllHandler, di as EmitterHandler, dr as Encoder, br as FilterFunction, dt as JsonEncoder, dk as ListenerSignature, dg as LocalChannel, d2 as LogLevel, d3 as LogLevelAlias, d4 as LogLevelAliasKey, b as LogLevelAliasType, d1 as Logger, d8 as LoggerConsoleHandler, d7 as LoggerContext, d6 as LoggerContextInterface, c as LoggerInterface, dd as LoggerMemoryHandler, bs as MapperFunction, e1 as MemStorage, e0 as MemStorageOptions, dx as Message, dv as MessageAction, dB as MessageDefinitions, dC as MessageHub, dw as MessageResult, dz as MessagesDefaultMethods, dA as MessagesMethods, dy as MessagesOptions, cy as Mutex, e5 as NestedArray, ds as NoopEncoder, cI as Pool, cE as PoolTask, cG as PoolTaskEvents, cC as PoolTaskFn, cF as PoolTaskIdConflictResolution, cD as PoolTaskState, bb as Primitive, dF as PubSub, dK as RPCFn, dJ as RPCOptions, dL as RPCReturn, au as RenderMessagesOptions, dI as ReturnType, bR as RoundingMode, cX as SerialQueue, c0 as SortableItem, cW as TaskEvents, cV as TaskFn, ae as Uint8ArrayToHexDump, ad as Uint8ArrayToJson, a2 as Uint8ArrayToString, cu as UseDefer, cr as UseDispose, cm as XRX, a0 as _decodeUtf8Polyfill, $ as _encodeUtf8Polyfill, M as arrayAvg, N as arrayBatches, y as arrayEmptyInPlace, w as arrayFilterInPlace, q as arrayFlatten, s as arrayIntersection, B as arrayIsEqual, H as arrayMax, I as arrayMin, o as arrayMinus, G as arrayRandomElement, u as arrayRemoveElement, v as arraySetElement, E as arrayShuffle, F as arrayShuffleForce, D as arrayShuffleInPlace, z as arraySorted, A as arraySortedNumbers, K as arraySum, t as arraySymmetricDifference, x as arrayToggleInPlace, p as arrayUnion, n as arrayUnique, bE as avg, bC as between, cg as cloneJsonObject, cf as cloneObject, bN as cmp, bM as composeOrderby, P as createArray, dh as createLocalChannelPair, cJ as createPromise, dD as createPromiseProxy, l as csvParse, m as csvParseToObjects, k as csvStringify, a$ as dateStringToDays, a_ as day, aD as dayDay, aT as dayDiff, aH as dayFromAny, aJ as dayFromDate, aK as dayFromDateGMT, aO as dayFromParts, aP as dayFromString, aM as dayFromTimestamp, aG as dayFromToday, aV as dayIterator, aC as dayMonth, aQ as dayMonthStart, aS as dayOffset, aU as dayRange, aF as dayToDate, aI as dayToDateGMT, aE as dayToParts, aN as dayToString, aL as dayToTimestamp, aB as dayYear, aR as dayYearStart, cZ as debounce, b2 as decimal, b5 as decimalCentsPart, b3 as decimalFromCents, b4 as decimalToCents, U as decodeBase16, R as decodeBase32, W as decodeBase58, Y as decodeBase62, j as decrypt, b6 as deepEqual, b8 as deepMerge, b7 as deepStripUndefinedInPlace, h as deriveKeyPbkdf2, dY as detect, g as digest, ce as empty, T as encodeBase16, Q as encodeBase32, V as encodeBase58, X as encodeBase62, c8 as encodeQuery, i as encrypt, c2 as endSortWeight, ca as ensureKey, cb as ensureKeyAsync, ab as equalBinary, b9 as escapeHTML, bQ as escapeRegExp, Z as estimateSizeForBase, dP as fetchBasic, dQ as fetchJson, dU as fetchOptionsBasicAuth, dS as fetchOptionsFormURLEncoded, dT as fetchOptionsJson, dR as fetchText, ax as fixBrokenUth8String, aY as forEachDay, cj as forTimes, av as formatMessages, e3 as formatMilliseconds, a9 as fromBase64, aa as fromBase64String, ai as fromCamelCase, a6 as fromHex, dX as getGlobal, c_ as getGlobalContext, dn as getGlobalEmitter, d0 as getGlobalLogger, d9 as getNamespaceFilterString, dW as getNavigator, bx as getSecureRandom, by as getSecureRandomIfPossible, e2 as getTimestamp, dV as getWindow, dN as httpMethod, cL as immediate, be as isArray, bl as isBoolean, dZ as isBrowser, bT as isEven, bS as isHalf, bj as isInteger, c$ as isLocalHost, bm as isNullOrUndefined, bi as isNumber, bc as isObject, bG as isPrime, bF as isPrimeRX, bd as isPrimitive, cS as isPromise, bf as isRecord, bg as isRecordPlain, bk as isSafeInteger, bh as isString, cP as isTimeout, bn as isUint8Array, a4 as joinToUint8Array, bq as jsonStringify, bp as jsonStringifySafe, bo as jsonStringifySorted, ac as jsonToUint8Array, cd as last, dq as lazyListener, c6 as linkifyPlainText, bv as listDistinctUnion, bu as listGroupBy, bw as listOfKey, bt as listQuery, ch as memoize, ci as memoizeAsync, dp as messages, c3 as moveSortWeight, bK as objectIsEmpty, bI as objectMap, bJ as objectMergeDisposable, dO as parseBasicAuth, e4 as parseDate, db as parseLogLevel, bL as parseOrderby, c9 as parseQuery, d_ as platform, cT as promisify, er as qid, bz as randomBoolean, bB as randomFloat, bA as randomInt, r as randomUint8Array, cl as regExpEscape, ck as regExpString, aw as renderMessages, bV as roundDown, bY as roundHalfAwayFromZero, bZ as roundHalfDown, b_ as roundHalfEven, bX as roundHalfOdd, b$ as roundHalfTowardsZero, bW as roundHalfUp, bU as roundUp, bH as seededRandom, el as setUuidDefaultEncoding, cc as size, cK as sleep, c4 as sortedItems, bO as sortedOrderby, c1 as startSortWeight, aj as stringToBoolean, al as stringToFloat, ak as stringToInteger, a1 as stringToUInt8Array, eh as suid, eg as suidBytes, ej as suidBytesDate, ei as suidDate, bD as sum, cY as throttle, cN as timeout, cM as timeoutReached, cO as timoutError, a7 as toBase64, a8 as toBase64Url, at as toBool, af as toCamelCase, ag as toCapitalize, ah as toCapitalizeWords, aq as toFloat, a5 as toHex, c7 as toHumanReadableUrl, ar as toInt, as as toString, a3 as toUint8Array, bP as toValidFilename, aZ as today, cQ as tryTimeout, eq as uname, ba as unescapeHTML, cB as useAsyncMutex, S as useBase, ct as useDefer, cq as useDispose, cs as useDisposer, cx as useEventListener, d$ as useExitHandler, cw as useInterval, dc as useLevelFilter, dE as useMessageHub, cA as useMutex, da as useNamespaceFilter, cH as usePool, dG as usePubSub, dM as useRPC, c5 as useSorted, cv as useTimeout, em as uuid, ek as uuid32bit, ea as uuidB32, e7 as uuidB62, e6 as uuidBytes, en as uuidDecode, ec as uuidDecodeB32, e9 as uuidDecodeB62, ef as uuidDecodeV4, eo as uuidEncode, eb as uuidEncodeB32, e8 as uuidEncodeB62, ee as uuidEncodeV4, ep as uuidIsValid, ed as uuidv4, am as valueToBoolean, ao as valueToFloat, an as valueToInteger, ap as valueToString, cR as waitOn } from './uuid-79482d19.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, Json, LogHandler, LogHandlerOptions, LogMessage, LoggerFileHandler, LoggerNodeHandler, ObjectStorage, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
